aboutsummaryrefslogtreecommitdiffstats
path: root/config/unbound
diff options
context:
space:
mode:
authorWarren Baker <warren@decoy.co.za>2011-11-06 19:10:18 +0200
committerWarren Baker <warren@decoy.co.za>2011-11-06 19:10:18 +0200
commite451d3eb49ecce077a994b24fbeea423bc6299be (patch)
treee16fc233b54cb50057adcbe9824f3dd4131642bc /config/unbound
parent8f0f4971a59eeb7e369fc5027144a9ae91d2698d (diff)
downloadpfsense-packages-e451d3eb49ecce077a994b24fbeea423bc6299be.tar.gz
pfsense-packages-e451d3eb49ecce077a994b24fbeea423bc6299be.tar.bz2
pfsense-packages-e451d3eb49ecce077a994b24fbeea423bc6299be.zip
Add Unbound monitor script (taken from proxy monitor) because TERM signal for the dhcpleases is killing it
Diffstat (limited to 'config/unbound')
-rw-r--r--config/unbound/unbound.xml6
-rwxr-xr-xconfig/unbound/unbound_monitor.sh66
2 files changed, 71 insertions, 1 deletions
diff --git a/config/unbound/unbound.xml b/config/unbound/unbound.xml
index e61b5a09..f8c33582 100644
--- a/config/unbound/unbound.xml
+++ b/config/unbound/unbound.xml
@@ -75,7 +75,11 @@
<chmod>0644</chmod>
<item>http://www.pfsense.org/packages/config/unbound/unbound_advanced.xml</item>
</additional_files_needed>
-
+ <additional_files_needed>
+ <prefix>/usr/local/etc/rc.d/</prefix>
+ <chmod>0755</chmod>
+ <item>http://www.pfsense.org/packages/config/unbound/unbound_monitor.sh</item>
+ </additional_files_needed>
<tabs>
<tab>
<text>Unbound DNS Settings</text>
diff --git a/config/unbound/unbound_monitor.sh b/config/unbound/unbound_monitor.sh
new file mode 100755
index 00000000..152a308e
--- /dev/null
+++ b/config/unbound/unbound_monitor.sh
@@ -0,0 +1,66 @@
+#!/bin/sh
+# $Id$ */
+#
+# unbound.sh
+# Copyright (C) 2011 Warren Baker
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are met:
+#
+# 1. Redistributions of source code must retain the above copyright notice,
+# this list of conditions and the following disclaimer.
+#
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
+# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
+# AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
+# AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
+# OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.
+#
+
+set -e
+
+LOOP_SLEEP=5
+
+if [ -f /var/run/unbound_alarm ]; then
+ rm /var/run/unbound_alarm
+fi
+
+# Sleep 5 seconds on startup not to mangle with existing boot scripts.
+sleep 5
+
+while [ /bin/true ]; do
+ if [ ! -f /var/run/unbound_alarm ]; then
+ NUM_PROCS=`/bin/pgrep unbound | wc -l | awk '{print $1}'`
+ if [ $NUM_PROCS -lt 1 ]; then
+ # Unbound is not running
+ echo "Unbound has exited." | logger -p daemon.info -i -t Unbound_Alarm
+ echo "Attempting restart..." | logger -p daemon.info -i -t Unbound_Alarm
+ /usr/local/etc/rc.d/unbound.sh start
+ sleep 3
+ touch /var/run/unbound_alarm
+ fi
+ fi
+ NUM_PROCS=`/bin/pgrep unbound | wc -l | awk '{print $1}'`
+ if [ $NUM_PROCS -gt 0 ]; then
+ if [ -f /var/run/unbound_alarm ]; then
+ echo "Unbound has resumed." | logger -p daemon.info -i -t Unbound_Alarm
+ rm /var/run/unbound_alarm
+ fi
+ fi
+ sleep $LOOP_SLEEP
+done
+
+if [ -f /var/run/unbound_alarm ]; then
+ rm /var/run/unbound_alarm
+fi
+